<template>
  <div class="login">
    <div class="title">
      <div class="logo">
        <img class="pics2" :src="logoPng">
        <span style="font-size: 40px;color: black">国泰新华</span>
        <div style="width: 2px;height: 40px;background-color: #1C68A7;margin-top: 5px;margin-left: 15px;margin-right: 15px"></div>
        <span style="font-size: 28px;color: white">安全在线教育平台</span>
      </div>
      <div class="content">
        <div class="imgBox">
          <div class="imG"></div>
        </div>
        <div class="formBox">
          <div class="loginTitle">账号登录</div>
          <div style="padding: 20px 0;">
            <el-form ref="loginRef" :model="loginForm" :rules="loginRules" class="login-form">
              <el-form-item>
                <div class="fromRow">
                  <el-input
                      v-model="loginForm.username"
                      type="text"
                      size="large"
                      auto-complete="off"
                      placeholder="请输入用户名"
                      style="height: 50px"
                  >
                    <template #prefix><svg-icon icon-class="user" class="el-input__icon input-icon" /></template>
                  </el-input>
                </div>
              </el-form-item>
              <el-form-item>
                <div class="fromRow">
                  <el-input
                      style="height: 50px"
                      v-model="loginForm.password"
                      type="password"
                      size="large"
                      auto-complete="off"
                      placeholder="请输入密码"
                      @keyup.enter="handleLogin"
                      show-password
                  >
                    <template #prefix><svg-icon icon-class="password" class="el-input__icon input-icon" /></template>
                  </el-input>
                </div>
              </el-form-item>
              <el-form-item>
                <div class="fromRow">
                  <el-input
                      v-model="loginForm.code"
                      size="large"
                      auto-complete="off"
                      placeholder="验证码"
                      style="height: 50px;width:63%"
                      @keyup.enter="handleLogin"
                  >
                    <template #prefix><svg-icon icon-class="validCode" class="el-input__icon input-icon" /></template>
                  </el-input>
                  <div class="login-code">
                    <img :src="codeUrl" @click="getCode" class="login-code-img"/>
                  </div>
                </div>
              </el-form-item>
              <el-form-item>
                <div class="fromRow">
                  <el-button
                      :loading="loading"
                      size="large"
                      type="primary"
                      style="width:100%;"
                      @click.prevent="handleLogin"
                  >
                    <span v-if="!loading">登 录</span>
                    <span v-else>登 录 中...</span>
                  </el-button>
                </div>
              </el-form-item>
            </el-form>
          </div>
        </div>
      </div>

    </div>
    <!--  底部  -->
    <div class="el-login-footer">
      <span>Copyright ©2024-{{nowYear}} All Rights Reserved.</span>
    </div>
<!--    <img class="pics1" :src="dataPng">-->
<!--    <img class="pics2" :src="searchPng">-->


<!--    <div class="login-panel">-->
<!--      <el-form ref="loginRef" :model="loginForm" :rules="loginRules" class="login-form">-->
<!--        <h3 class="title">安全在线教育平台</h3>-->
<!--        <el-form-item prop="username">-->
<!--          <el-input-->
<!--              v-model="loginForm.username"-->
<!--              type="text"-->
<!--              size="large"-->
<!--              auto-complete="off"-->
<!--              placeholder="账号"-->
<!--          >-->
<!--            <template #prefix><svg-icon icon-class="user" class="el-input__icon input-icon" /></template>-->
<!--          </el-input>-->
<!--        </el-form-item>-->
<!--        <el-form-item prop="password">-->
<!--          <el-input-->
<!--              v-model="loginForm.password"-->
<!--              type="password"-->
<!--              size="large"-->
<!--              auto-complete="off"-->
<!--              placeholder="密码"-->
<!--              @keyup.enter="handleLogin"-->
<!--              show-password-->
<!--          >-->
<!--            <template #prefix><svg-icon icon-class="password" class="el-input__icon input-icon" /></template>-->
<!--          </el-input>-->
<!--        </el-form-item>-->
<!--        <el-form-item prop="code" v-if="captchaEnabled">-->
<!--          <el-input-->
<!--              v-model="loginForm.code"-->
<!--              size="large"-->
<!--              auto-complete="off"-->
<!--              placeholder="验证码"-->
<!--              style="width: 63%"-->
<!--              @keyup.enter="handleLogin"-->
<!--          >-->
<!--            <template #prefix><svg-icon icon-class="validCode" class="el-input__icon input-icon" /></template>-->
<!--          </el-input>-->
<!--          <div class="login-code">-->
<!--            <img :src="codeUrl" @click="getCode" class="login-code-img"/>-->
<!--          </div>-->
<!--        </el-form-item>-->
<!--        <el-form-item style="width:100%;">-->
<!--          <el-button-->
<!--              :loading="loading"-->
<!--              size="large"-->
<!--              type="primary"-->
<!--              style="width:100%;"-->
<!--              @click.prevent="handleLogin"-->
<!--          >-->
<!--            <span v-if="!loading">登 录</span>-->
<!--            <span v-else>登 录 中...</span>-->
<!--          </el-button>-->
<!--        </el-form-item>-->
<!--      </el-form>-->
<!--    </div>-->
  </div>
</template>

<script setup>
import {onMounted, ref, watch, defineAsyncComponent, nextTick} from "vue"
import { getCodeImg } from "@/api/login";
import Cookies from "js-cookie";
import { encrypt, decrypt } from "@/utils/jsencrypt";
import useUserStore from '@/store/modules/user'
import { Base64 } from 'js-base64'
import menu from "@/layout/components/Sidebar/menu";
import dataPng from "@/assets/images/login-data.png"
import searchPng from "@/assets/images/login-search.png"
import logoPng from "@/assets/logo/logo1.png"

const userStore = useUserStore()
const route = useRoute();
const router = useRouter();
const { proxy } = getCurrentInstance();
const nowYear = ref();
// 时间格式化
const timeForm = {
  hour12: false,
  year: 'numeric',
  month: '2-digit',
  day: '2-digit',
  hour: '2-digit',
  minute: '2-digit',
  second: '2-digit'
}

const loginForm = ref({
  username: "",
  password: "",
  code: "",
  uuid: ""
});

const loginRules = {
  username: [{ required: true, trigger: "blur", message: "请输入您的账号" }],
  password: [{ required: true, trigger: "blur", message: "请输入您的密码" }],
  code: [{ required: true, trigger: "change", message: "请输入验证码" }]
};

const codeUrl = ref("");
const loading = ref(false);
const regRef = ref(null)
// 验证码开关
const captchaEnabled = ref(true);
// 注册开关
const isRegister = ref(false);
const redirect = ref(undefined);

onMounted(()=>{
  const curTime = new Date().toLocaleString('zh', timeForm).replace(/\//g, '-');
  nowYear.value = curTime.slice(0, 4);
})

const openRegist = ()=>{
  regRef.value.dialogVisible = true
}

watch(route, (newRoute) => {
  redirect.value = newRoute.query && newRoute.query.redirect;
}, { immediate: true });

const sidebarRouters = ref([])
function handleLogin() {
  proxy.$refs.loginRef.validate(valid => {
    if (valid) {
      loading.value = true;
      // 勾选了需要记住密码设置在 cookie 中设置记住用户名和密码
      // if (loginForm.value.rememberMe) {
      Cookies.set("username", loginForm.value.username, { expires: 30 });
      Cookies.set("password", encrypt(loginForm.value.password), { expires: 30 });
      //   Cookies.set("rememberMe", loginForm.value.rememberMe, { expires: 30 });
      // } else {
      // 否则移除
      //   Cookies.remove("username");
      //   Cookies.remove("password");
      //   Cookies.remove("rememberMe");
      // }
      // 调用action的登录方法
      // loginForm.value.password = Base64.encode(loginForm.value.password)
      const param = {
        username: loginForm.value.username,
        password: Base64.encode(loginForm.value.password),
        code: loginForm.value.code,
        uuid: loginForm.value.uuid,
        identity: loginForm.value.role
      }
      userStore.login(param).then(() => {
        // const query = route.query;
        // const otherQueryParams = Object.keys(query).reduce((acc, cur) => {
        //   if (cur !== "redirect") {
        //     acc[cur] = query[cur];
        //   }
        //   return acc;
        // }, {});

        //暂时不分角色
        // const userInfo = JSON.parse(Cookies.get('userInfo'))
        // if(userInfo.identity === 0 ) {
        //   //监管用户（管理员）
        //   sidebarRouters.value =  menu.adminMenu
        //   Cookies.set('routers',JSON.stringify(sidebarRouters.value))
        // }else if(userInfo.identity === 1) {
        //   sidebarRouters.value =  menu.agencyMenu
        //   Cookies.set('routers',JSON.stringify(sidebarRouters.value))
        // }
        const userInfo = JSON.parse(Cookies.get('userInfo'))
        if(userInfo.userType === 0) {
          sidebarRouters.value =  menu.adminMenu
          Cookies.set('routers',JSON.stringify(sidebarRouters.value))
        }else {
          sidebarRouters.value =  menu.companyMenu
          Cookies.set('routers',JSON.stringify(sidebarRouters.value))
        }
        let path = ""
        if(sidebarRouters.value[0].children && sidebarRouters.value[0].children.length > 0){
          path = sidebarRouters.value[0].path + '/'+ sidebarRouters.value[0].children[0].path
        }else {
          path = sidebarRouters.value[0].path
        }

        router.push({
          path: path
        })
        // router.push({ path: redirect.value || "/", query: otherQueryParams });
      }).catch(() => {
        loading.value = false;
        // 重新获取验证码
        if (captchaEnabled.value) {
          getCode();
        }
      });
    }
  });
}

function getCode() {
  getCodeImg().then(res => {
    captchaEnabled.value = res.data.captchaEnabled
    if (captchaEnabled.value) {
      codeUrl.value = "data:image/gif;base64," + res.data.image
      loginForm.value.uuid = res.data.uuid
    }
  });
}


getCode();
</script>

<style lang='scss' scoped>
.login {
  margin: 0;
  padding: 0;
  font-family: "microsoft yahei";
  font-size: 14px;
  //background: #04C1F8;
  background: #04C1F8 url(../assets/images/bgpag.png) no-repeat;
  //background-repeat: no-repeat;
  background-size: cover;
  height: 100%;
  :deep(.el-form-item__content .el-form-item) {
    display: block;
  }
  :deep(.el-form-item--default) {
    margin-bottom: -25px;
  }
}
.logo {
  display: flex;
  align-items: center;
  padding-top: 80px;
}
.pics1{
  position: absolute;
  width: 500px;
  bottom: 0;
  right: 0;
  opacity: 0.5;
}
.pics2{
  width:60px;
  //top: 20px;
  //left: 20px;

}
.content{
  position: relative;
}
.imgBox {
  width: 560px;
  height: 560px;
  margin-top: 80px;
  float: left;
  position: relative;
}
.fromRow{
  width: 100%;
  margin: 25px 0;
}
.imG{
  width: 500px;
  height: 500px;
  background-image: url(../assets/images/ad.png) ;
  background-repeat: no-repeat;
  position: absolute;
  left: 30px;
  top: 30px;
}
.formBox{
  width: 370px;
  height: 400px;
  border-radius: 5px;
  background: rgba(25,25,25,0.6);
  margin-top: 130px;
  padding: 20px;
  float: right;
}
.loginTitle{
  width: 100%;
  text-align: center;
  font-size: 16px;
  color: #FFF;
  line-height: 50px;
  border-bottom: 1px solid #FFF;
}
.title {
  width: 90%;
  height: auto;
  max-width: 1200px;
  margin: 0 auto;
}
.login-panel{
  border-radius: 1.2rem;
  background: #ffffff;
  width: 550px;
  display: flex;
  justify-content: center;
  align-items: center;
  transform: translateY(-20%);
  box-shadow: 15px 15px 30px rgba(0,0,0,.1);
}
.login-img{
  flex: 1;
  display: flex;
  justify-content: center;
  align-items: center;
  img{
    width: 80%;
  }
}
//.login-form {
//  flex: 1;
//  padding: 25px;
//  .el-input {
//    height: 44px;
//    input {
//      height: 44px;
//    }
//  }
//  .input-icon {
//    height: 39px;
//    width: 14px;
//    margin-left: 0px;
//  }
//}
.login-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}
.login-code {
  width: 33%;
  height: 40px;
  float: right;
  img {
    cursor: pointer;
    vertical-align: middle;
  }
}

.el-form-item--default{
  margin-bottom: 24px;
}

::v-deep(.el-form-item__content){
  display: flex;
  justify-content: space-between;
}
.el-login-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}
.login-code-img {
  margin-top: 5px;
  width: 90px;
  height: 40px;
  padding-left: 7px;
}

@media screen and (max-width: 980px) {
  .imG {
    display: none;
  }
  .imgBox {
   width: 0;
  }
  .formBox{
    width: 100%;
  }
}


</style>
